import { PreactCustomElement } from '..';
import { ClassAccessorDecorator } from './utils';
/**
 * Add a listener property that gets/sets an event listener.
 *
 * The property name must start with "on" and be lowercase.
 *
 * The event name is the property name, without the "on" prefix.
 *
 * @example
 * ```ts
 * class Table extends PreactCustomElement {
 *   @listener()
 *   onangryflip!: (event: Event) => void;
 * }
 */
export default function listener<T extends Event = Event>(): ClassAccessorDecorator<PreactCustomElement, ((event: T) => void) | null>;
