/**
 * Truthy values mean the attribute is set (with an empty value), otherwise no attribute is set.
 */
function boolean() {
    return {
        defaultValue: false,
        parseAttribute(value) {
            return typeof value === 'string';
        },
        set(value, setter) {
            setter(Boolean(value));
        },
        toAttribute(value) {
            return value ? '' : null;
        },
    };
}

export { boolean };
