import { createStylesheet, y, __setFunctionName, __esDecorate, __runInitializers, PreactCustomElement, __classPrivateFieldGet, __classPrivateFieldSet } from '../../chunks/index.js';
import { reactive, define } from '../../chunks/define.js';
import { boolean } from '../../chunks/boolean.js';
import { stringEnum } from '../../chunks/stringEnum.js';
import { tagName } from './meta.js';
import { classMap } from '../../chunks/classMap.js';
import { layoutStyles } from '../../chunks/layout.js';

const componentStyles = createStylesheet(".card,.shadow{border-radius:.5rem}.card{display:flex;position:relative;box-shadow:.0625rem 0 0 0 rgba(0,0,0,.13) inset,-.0625rem 0 0 0 rgba(0,0,0,.13) inset,0-.0625rem 0 0 rgba(0,0,0,.17) inset,0 .0625rem 0 0 rgba(204,204,204,.5) inset}.shadow{position:absolute;top:0;right:0;bottom:0;left:0;z-index:0;box-shadow:0 .0625rem 0 0 rgba(26,26,26,.07);pointer-events:none;mix-blend-mode:luminosity}.bg-transparent{background-color:transparent}.bg-base{background-color:#f1f1f1}.bg-subdued{background-color:#f3f3f3}.padding{padding:1rem}");

const styles = [componentStyles, layoutStyles];
function ShadowRoot(element) {
    const { padding, background } = element;
    return (y("div", { class: classMap({
            card: true,
            [`bg-${background}`]: true,
            padding: padding === true,
        }) },
        y("div", { class: "shadow" }),
        y("slot", null)));
}

const shadow = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.defineProperty({
      __proto__: null,
      ShadowRoot,
      styles
}, Symbol.toStringTag, { value: 'Module' }));

let Card = (() => {
    var _Card_padding_accessor_storage, _Card_background_accessor_storage;
    let _classDecorators = [define(tagName)];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = PreactCustomElement;
    let _instanceExtraInitializers = [];
    let _padding_decorators;
    let _padding_initializers = [];
    let _background_decorators;
    let _background_initializers = [];
    _classThis = class extends _classSuper {
        get padding() { return __classPrivateFieldGet(this, _Card_padding_accessor_storage, "f"); }
        set padding(value) { __classPrivateFieldSet(this, _Card_padding_accessor_storage, value, "f"); }
        get background() { return __classPrivateFieldGet(this, _Card_background_accessor_storage, "f"); }
        set background(value) { __classPrivateFieldSet(this, _Card_background_accessor_storage, value, "f"); }
        constructor() {
            super(shadow);
            _Card_padding_accessor_storage.set(this, (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _padding_initializers, void 0)));
            _Card_background_accessor_storage.set(this, __runInitializers(this, _background_initializers, void 0));
        }
    };
    _Card_padding_accessor_storage = new WeakMap();
    _Card_background_accessor_storage = new WeakMap();
    __setFunctionName(_classThis, "Card");
    (() => {
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _padding_decorators = [reactive(boolean())];
        _background_decorators = [reactive(stringEnum(['transparent', 'base', 'subdued']))];
        __esDecorate(_classThis, null, _padding_decorators, { kind: "accessor", name: "padding", static: false, private: false, access: { has: obj => "padding" in obj, get: obj => obj.padding, set: (obj, value) => { obj.padding = value; } }, metadata: _metadata }, _padding_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _background_decorators, { kind: "accessor", name: "background", static: false, private: false, access: { has: obj => "background" in obj, get: obj => obj.background, set: (obj, value) => { obj.background = value; } }, metadata: _metadata }, _background_initializers, _instanceExtraInitializers);
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return _classThis;
})();

export { Card as default };
