import { PreactCustomElement } from '../../PreactCustomElement';
import { tagName } from './meta';
export interface SharedProps {
    /**
     * Divider direction
     * @default 'block'
     */
    direction: 'block' | 'inline';
}
export default class Divider extends PreactCustomElement implements SharedProps {
    accessor direction: SharedProps['direction'];
    constructor();
}
declare global {
    interface HTMLElementTagNameMap {
        [tagName]: Divider;
    }
}
declare module 'preact' {
    namespace createElement.JSX {
        interface IntrinsicElements {
            [tagName]: Partial<Divider>;
        }
    }
}
