import { PreactCustomElement } from '..';
import { Reflector } from '../reflectors/utils';
import { ClassAccessorDecorator } from './utils';
interface ReactiveOptions<InstanceType extends PreactCustomElement> {
    /** Which attribute to reflect to. `false` to reflect to a private property. */
    attribute?: false | string;
    /** Called when the value changes. */
    onChange?(instance: InstanceType): void;
}
/**
 * Define this accessor as a reactive property.
 * This means the render function will run whenever this property (or the associated attribute) changes.
 *
 * @param reflector A reflector to handle getting, setting, and converting to/from attributes.
 * @param options
 */
export default function reactive<InstanceType extends PreactCustomElement, ValueType>(reflector: Reflector<ValueType>, { attribute, onChange }?: ReactiveOptions<InstanceType>): ClassAccessorDecorator<InstanceType, ValueType>;
export {};
