import { ComponentChild } from 'preact';
type Style = string | CSSStyleSheet;
type Styles = Style[] | Style;
export type RenderImpl = {
    ShadowRoot: (element: any) => ComponentChild;
    styles?: Styles;
};
declare const BaseClass: {
    new (): HTMLElement;
    prototype: HTMLElement;
};
export declare abstract class PreactCustomElement extends BaseClass {
    #private;
    static get observedAttributes(): string[];
    constructor({ styles, ShadowRoot: renderFunction }: RenderImpl);
    attributeChangedCallback(name: string): void;
    /**
     * Queue a run of the render function.
     * You shouldn't need to call this manually - it should be handled by changes to @property values.
     */
    queueRender(): void;
    /**
     * Internal function to add styles for legacy browsers.
     *
     * @private
     */
    _addLegacyStyleComponent(style: string): void;
}
export {};
