import { Reflector } from './utils';
export interface NumberOptions {
    /**
     * The minimum value allowed.
     */
    min?: number;
    /**
     * The maximum value allowed.
     */
    max?: number;
    /**
     * If true, round down to the nearest integer, before clamping.
     */
    floor?: boolean;
    /**
     * The default value to use if unset, or invalid.
     */
    defaultValue?: number;
}
/**
 * Cast the value to a number.
 *
 * @param options
 */
export default function number({ min, max, floor, defaultValue, }?: NumberOptions): Reflector<number>;
