/**
 * @param classes Object with a class name as the key and a boolean for the value. The boolean value is used to determine if its associated class name should be included in the final output
 * @returns string
 */
const classMap = (classes) => {
    let classesString = '';
    for (const className in classes) {
        const included = Boolean(classes[className]);
        if (included) {
            classesString += `${className} `;
        }
    }
    return classesString.trim();
};

export { classMap };
