import { PreactCustomElement } from '../../PreactCustomElement';
import { tagName } from './meta';
export interface SharedProps {
    /**
     * Adjust the padding of all edges.
     *
     * `true` applies a default padding that is appropriate for the component.
     *
     * @default: `true`
     */
    padding: boolean;
    /**
     * Adjust the background of the element.
     *
     * @default: 'transparent'
     */
    background: 'transparent' | 'base' | 'subdued';
}
export default class Card extends PreactCustomElement implements SharedProps {
    accessor padding: boolean;
    accessor background: SharedProps['background'];
    constructor();
}
declare global {
    interface HTMLElementTagNameMap {
        [tagName]: Card;
    }
}
declare module 'preact' {
    namespace createElement.JSX {
        interface IntrinsicElements {
            [tagName]: Partial<Card>;
        }
    }
}
