import { createStylesheet, y, __setFunctionName, __esDecorate, __runInitializers, PreactCustomElement, __classPrivateFieldGet, __classPrivateFieldSet } from '../../chunks/index.js';
import { reactive, define } from '../../chunks/reactive.js';
import { tagName } from './meta.js';
import { stringEnum } from '../../chunks/stringEnum.js';
import { F } from '../../chunks/hooks.js';
import { layoutStyles } from '../../chunks/layout.js';

const componentStyles = createStylesheet(":host([direction='block']){width:auto}.divider{margin:0;border-width:0;border-style:solid}");

// This file is generated by lib/optimizedPolarisTokensPlugin.mjs
const borderWidth025 = "0.0625rem";

// This file is generated by lib/optimizedPolarisTokensPlugin.mjs
const colorBorderSecondary = "rgba(235, 235, 235, 1)";

const styles = [componentStyles, layoutStyles];
function ShadowRoot(element) {
    const { direction } = element;
    const directionalStyles = F(() => direction === 'block'
        ? {
            'min-block-size': '100%',
            'border-inline-start-width': borderWidth025,
        }
        : {
            'border-block-end-width': borderWidth025,
        }, [direction]);
    return (y("hr", { class: "divider", style: {
            borderColor: colorBorderSecondary,
            ...directionalStyles,
        } }));
}

const shadow = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.defineProperty({
      __proto__: null,
      ShadowRoot,
      styles
}, Symbol.toStringTag, { value: 'Module' }));

let Divider = (() => {
    var _Divider_direction_accessor_storage;
    let _classDecorators = [define(tagName)];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = PreactCustomElement;
    let _instanceExtraInitializers = [];
    let _direction_decorators;
    let _direction_initializers = [];
    _classThis = class extends _classSuper {
        get direction() { return __classPrivateFieldGet(this, _Divider_direction_accessor_storage, "f"); }
        set direction(value) { __classPrivateFieldSet(this, _Divider_direction_accessor_storage, value, "f"); }
        constructor() {
            super(shadow);
            _Divider_direction_accessor_storage.set(this, (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _direction_initializers, void 0)));
        }
    };
    _Divider_direction_accessor_storage = new WeakMap();
    __setFunctionName(_classThis, "Divider");
    (() => {
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _direction_decorators = [reactive(stringEnum(['inline', 'block']))];
        __esDecorate(_classThis, null, _direction_decorators, { kind: "accessor", name: "direction", static: false, private: false, access: { has: obj => "direction" in obj, get: obj => obj.direction, set: (obj, value) => { obj.direction = value; } }, metadata: _metadata }, _direction_initializers, _instanceExtraInitializers);
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return _classThis;
})();

export { Divider as default };
