import { createStylesheet, y, __setFunctionName, __esDecorate, __runInitializers, PreactCustomElement, __classPrivateFieldGet, __classPrivateFieldSet } from '../../chunks/index.js';
import { define, reactive } from '../../chunks/reactive.js';
import { string } from '../../chunks/string.js';
import { tagName } from './meta.js';

const shadow$1 = createStylesheet("");

function ShadowRoot(element) {
    // The render function is a Preact component that receives the element as a prop.
    // You can use anything here you'd usually use in Preact, such as hooks, signals, JSX etc.
    // except the `children` prop; use `<slot />` instead.
    const { foo, bar } = element;
    return (y("div", null,
        foo,
        " ",
        bar));
}

const shadow = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.defineProperty({
      __proto__: null,
      ShadowRoot,
      styles: shadow$1
}, Symbol.toStringTag, { value: 'Module' }));

let RenameMe = (() => {
    var _RenameMe_foo_accessor_storage, _RenameMe_bar_accessor_storage;
    let _classDecorators = [define(tagName)];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = PreactCustomElement;
    let _instanceExtraInitializers = [];
    let _foo_decorators;
    let _foo_initializers = [];
    let _bar_decorators;
    let _bar_initializers = [];
    _classThis = class extends _classSuper {
        // Define getter/setter properties, that may reflect to attributes.
        get foo() { return __classPrivateFieldGet(this, _RenameMe_foo_accessor_storage, "f"); }
        set foo(value) { __classPrivateFieldSet(this, _RenameMe_foo_accessor_storage, value, "f"); }
        get bar() { return __classPrivateFieldGet(this, _RenameMe_bar_accessor_storage, "f"); }
        set bar(value) { __classPrivateFieldSet(this, _RenameMe_bar_accessor_storage, value, "f"); }
        constructor() {
            super(shadow);
            _RenameMe_foo_accessor_storage.set(this, (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _foo_initializers, void 0)));
            _RenameMe_bar_accessor_storage.set(this, __runInitializers(this, _bar_initializers, void 0));
        }
    };
    _RenameMe_foo_accessor_storage = new WeakMap();
    _RenameMe_bar_accessor_storage = new WeakMap();
    __setFunctionName(_classThis, "RenameMe");
    (() => {
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _foo_decorators = [reactive(string())];
        _bar_decorators = [reactive(string())];
        __esDecorate(_classThis, null, _foo_decorators, { kind: "accessor", name: "foo", static: false, private: false, access: { has: obj => "foo" in obj, get: obj => obj.foo, set: (obj, value) => { obj.foo = value; } }, metadata: _metadata }, _foo_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _bar_decorators, { kind: "accessor", name: "bar", static: false, private: false, access: { has: obj => "bar" in obj, get: obj => obj.bar, set: (obj, value) => { obj.bar = value; } }, metadata: _metadata }, _bar_initializers, _instanceExtraInitializers);
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return _classThis;
})();

export { RenameMe as default };
