import type { ReactNode } from 'react';
export type React = {
    forwardRef: typeof import('react').forwardRef;
    useRef: typeof import('react').useRef;
    useLayoutEffect: typeof import('react').useLayoutEffect;
    useCallback: typeof import('react').useCallback;
    Children: typeof import('react').Children;
    createElement: typeof import('react').createElement;
    useMemo: typeof import('react').useMemo;
};
type EventArgMap<Props extends object> = {
    [Property in keyof Props]?: (event: Event) => unknown[];
};
type Slots<Props extends object> = (keyof Props)[];
export interface PropConfig<Props extends object> {
    slots?: Slots<Props>;
    eventArgMap?: EventArgMap<Props>;
}
type PropsWithChildren<T> = T extends {
    children: ReactNode;
} ? T : React.PropsWithChildren<T>;
export default function reactWrap<Props extends object, ElementType extends HTMLElement>(React: React, tagName: string, { slots, eventArgMap }?: PropConfig<Props>): import("react").ForwardRefExoticComponent<import("react").PropsWithoutRef<PropsWithChildren<Props>> & import("react").RefAttributes<ElementType>>;
export {};
